<?php
/* 
                                                                                          2007-09-05
                                                                                 sync4db/sync4db.php
This file is part of sync4db

sync4db is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

sync4db is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/
require_once '_db/ini.db.inc';
require_once 'XML/RPC.php';
require_once 'MDB2.php';
require_once 'MDB/QueryTool.php';
require_once 'sync4db.inc';

                            $app           = 'sync4db';
if (!isset($username))      $username      = 'username';            // modify !!!
if (!isset($password))      $password      = 'password';            // modify !!!
if (!isset($dbname))        $dbname        = substr($dsn,strrpos($dsn,"/")+1);
if (!isset($HTTP_username)) $HTTP_username = 'username';            // modify !!!
if (!isset($HTTP_password)) $HTTP_password = 'password';            // modify !!!
if (!isset($server_dbname)) $server_dbname = 'server_dbname';       // modify !!!
if (!isset($server_url))    $server_url    = 'http://server_url';   // modify !!!
if (!isset($server_path))   $server_path   = 'sync4db_server.php5'; // modify !!!
                            $port          = 80;

if (isset($_REQUEST['server_url'])) {
  $server_path = preg_replace('#(http://.*?)(/.*sync4db_server.*)#','\\2',$_REQUEST['server_url']);
  $server_url  = preg_replace('#(http://.*?)(/.*sync4db_server.*)#','\\1',$_REQUEST['server_url']);
  }
else {
  $_REQUEST['server_url'] = $server_url.$server_path;
  }
if (isset($_REQUEST['dbname']))
  $dsn = substr($dsn,0,strrpos($dsn,'/')+1).$_REQUEST['dbname'];
else
  $_REQUEST['dbname'] = substr($dsn,strrpos($dsn,"/")+1);

class Tabelle extends MDB_QueryTool {};
$mdb2     =& MDB2::factory($dsn);
$tabliste = $mdb2->mgListTables();
$tab      = new Tabelle($dsn,array(),2);
$tabname  = setTable($tab,$tabliste);
$primCol  = setPrimaryCol($tab);
class Tabelle2 extends MDB_QueryTool {};
$tab2     = new Tabelle2($dsn,array(),2);

$r_tabname= isset($_REQUEST['r_tabname'])?$_REQUEST['r_tabname']:$_REQUEST['r_tabname'] = $tabname;
$params   = array(new XML_RPC_Value($app),
                  new XML_RPC_Value($username),
                  new XML_RPC_Value(md5($password)), // crypt password for public transfer
                  new XML_RPC_Value($dbname));
                               
$call_remote = true;
//------------------------------------------------------------------------------
  print getHTMLProlog();
  if ($_REQUEST['action'] == 'r_remove') {
    $params[] = new XML_RPC_Value($r_tabname);
    $msg      = new XML_RPC_Message('sync.removeTab', $params);
    $resp     = client_sent($msg);
    $_REQUEST['r_tabname'] = $tabname;
    $_REQUEST['action']='';
    }
  elseif ($_REQUEST['action'] == 'remove') {
    $mdb2->query('DROP TABLE '.$tabname);
    $_REQUEST['tabname'] = $tabliste[0];
    $_REQUEST['action']='';
    $call_remote = false;
    }
  elseif ($_REQUEST['action'] == 'r_truncate') {
    $params[] = new XML_RPC_Value($r_tabname);
    $msg      = new XML_RPC_Message('sync.truncateTab', $params);
    $resp     = client_sent($msg);
    $_REQUEST['action']='';
     }
  elseif ($_REQUEST['action'] == 'truncate') {
    $mdb2->query('TRUNCATE TABLE '.$tabname);
    $_REQUEST['action']='';
    $call_remote = false;
     }
  elseif ($_REQUEST['r_new_name'] <> '') {
    $params[] = new XML_RPC_Value($r_tabname);
    $params[] = new XML_RPC_Value($_REQUEST['r_new_name']);
    $msg      = new XML_RPC_Message('sync.renameTab', $params);
    $_REQUEST['r_tabname'] = client_sent($msg);
    $_REQUEST['r_new_name']='';
    }
  elseif ($_REQUEST['new_name'] <> '') {
    if ($tabname <> $_REQUEST['new_name'])
      $mdb2->query('RENAME TABLE '.$tabname.' TO '.$_REQUEST['new_name']);
    $_REQUEST['tabname'] = $_REQUEST['new_name'];
    $_REQUEST['new_name'] = '';
    $call_remote = false;
    }
  elseif ($_REQUEST['r_clone_tab'] <> '') {
    $params[] = new XML_RPC_Value($r_tabname);
    $params[] = new XML_RPC_Value($_REQUEST['r_clone_tab']);
    $msg      = new XML_RPC_Message('sync.cloneTab', $params);
    $_REQUEST['r_new_name'] = client_sent($msg);
    $_REQUEST['r_clone_tab']='';
    }
  elseif ($_REQUEST['clone_tab'] <> '') {
    if ($tabname <> $_REQUEST['clone_tab'])
      $mdb2->query('CREATE TABLE '.$_REQUEST['clone_tab'].' LIKE '.$tabname);
    $_REQUEST['clone_tab'] = '';
    $call_remote = false;
    }
  elseif ($_REQUEST['r_copy'] <> '') {
    $params[] = new XML_RPC_Value($r_tabname);
    $params[] = new XML_RPC_Value($_REQUEST['r_copy']);
    $msg      = new XML_RPC_Message('sync.copyTab', $params);
    $_REQUEST['r_new_name'] = client_sent($msg);
    $_REQUEST['r_copy'] = '';
    }
  elseif ($_REQUEST['copy'] <> '') {
    if ($tabname <> $_REQUEST['copy'])
      $mdb2->query('INSERT INTO '.$_REQUEST['copy'].' SELECT * FROM '.$tabname);
    $_REQUEST['copy'] = '';
    $call_remote = false;
    }
  elseif ($_REQUEST['clone_tab_local'] <> '') {
    $params[] = new XML_RPC_Value($_REQUEST['clone_tab_local']);
    $data     = $mdb2->queryAll('SHOW CREATE TABLE '.$tabname);
    $tstruct  = preg_replace('/^.*?(\(.*)/','\\1',$data[0][1]);
    $params[] = new XML_RPC_Value($tstruct);
    $msg      = new XML_RPC_Message('sync.cloneTabFromLocal', $params);
    $_REQUEST['r_new_name'] = client_sent($msg);
    $_REQUEST['clone_tab_local'] = '';
    }
  elseif ($_REQUEST['clone_tab_remote'] <> '') {
    $params[] = new XML_RPC_Value($r_tabname);
    $msg      = new XML_RPC_Message('sync.cloneTabFromRemote', $params);
    $tstruct  = client_sent($msg);
    $mdb2->query('CREATE TABLE '.$_REQUEST['clone_tab_remote'].' '.$tstruct);
    $_REQUEST['clone_tab_remote'] = '';
    }
  elseif ($_REQUEST['rid'] <> '') {
    $params[] = new XML_RPC_Value($r_tabname);
    sync_local($tab,$_REQUEST['rid']);
    $_REQUEST['rid']='';
    }
  elseif ($_REQUEST['lid'] <> '') {
    $params[] = new XML_RPC_Value($r_tabname);
    sync_remote($tab,$_REQUEST['lid']);
    $_REQUEST['lid']='';
    }
  elseif ($_REQUEST['lid1'] <> '') {
    print '<fieldset style="position:absolute;top:200px;left:200px;padding:20px;
    background:#444;border-color:#f00;visibility:block;color:#fff;" title="click to hide"
    onclick="this.style.visibility=\'hidden\'"><legend>sync done</legend>'
    .$tabname.'['.$_REQUEST['lid1'].'] &#8594; '.$_REQUEST['sync_local'].'</fieldset>';
    $tab2->setTable($_REQUEST['sync_local']);
    $tab2->primaryCol=$tab1->primaryCol;
    $tab2->remove($_REQUEST['lid1']);
    $tab2->add($tab->get($_REQUEST['lid1']));
    $_REQUEST['lid1']='';
    $call_remote = false;
    }
  elseif ($_REQUEST['lid2'] <> '') {
    print '<fieldset style="position:absolute;top:200px;left:200px;padding:20px;
    background:#444;border-color:#f00;visibility:block;color:#fff;" title="click to hide"
    onclick="this.style.visibility=\'hidden\'"><legend>sync done</legend>'
    .$_REQUEST['sync_local'].'['.$_REQUEST['lid2'].'] &#8594; '.$tabname.'</fieldset>';
    $tab2->setTable($_REQUEST['sync_local']);
    setPrimaryCol($tab2);
    $tab->remove($_REQUEST['lid2']);
    $tab->add($tab2->get($_REQUEST['lid2']));
    $_REQUEST['lid2']='';
    $call_remote = false;
    }
  elseif ($_REQUEST['action_sync'] == 'sync_local') $call_remote = false;
  print '<form name="f" class="f" method="post" action="'.$_SERVER['PHP_SELF'].'">'
      . '<input type="hidden" id="action"      name="action" value=""></input>'
      . '<input type="hidden" id="action_sync" name="action_sync" value='.$_REQUEST['action_sync'].'></input>';
  print getServer();
  if ($call_remote) print @getRemoteHTMLTabList();
  $out .= '<input type="button" class="i" name="action"'
       .  ' onclick="var ok=confirm(\''.$r_tabname.': table remove?\');'
       .  ' if (ok) document.getElementById(\'action\').value=\'r_remove\';submit();" value="remove"></input>';
  $out .= '<input type="button" class="i" name="action"'
       .  ' onclick="var ok=confirm(\''.$r_tabname.': table truncate?\');'
       .  ' if (ok) document.getElementById(\'action\').value=\'r_truncate\';submit();" value="truncate"></input>';
  $out .= '<input type="button" class="i" name="action"'
       .  ' onclick="document.getElementById(\'ran\').style.display=\'inline\'"'
       .  ' value="rename"></input>'
       .  '<input type="text" id="ran" name="r_new_name" style="display:none" onchange="submit()"></input>';
  $out .= '<input type="button" class="i" name="action" title="clone table definition [CREATE TABLE tab2 LIKE tab1]"'
       .  ' onclick="document.getElementById(\'rcn\').style.display=\'inline\'"'
       .  ' value="clone"></input>'
       .  '<input type="text" id="rcn" name="r_clone_tab" style="display:none" onchange="submit()"></input>';
  $out .= '<input type="button" class="i" name="action" title="copy table data on remote host [INSERT INTO tab1 SELECT * FROM tab2]"'
       .  ' onclick="document.getElementById(\'rcp\').style.display=\'inline\'"'
       .  ' value="copy data"></input>'
       .  '<input type="text" id="rcp" name="r_copy" style="display:none" onchange="submit()"></input>';
  $out .= '<input type="button" class="j" name="action" title="clone local table definition to remote [CREATE TABLE r_tab LIKE l_tab]"'
       .  ' onclick="document.getElementById(\'clt\').style.display=\'inline\'"'
       .  ' value="clone local table"></input>'
       .  '<input type="text" id="clt" name="clone_tab_local" style="display:none" onchange="submit()"></input>';
  if ($call_remote) print $out . '</fieldset>';
  print getHTMLDBList($mdb2);
  print getHTMLTabList($tab,$mdb2->mgListTables());
  $out = ' <input type="button" class="i" name="action"'
       .  ' onclick="var ok=confirm(\''.$tabname.': table remove?\');'
       .  ' if (ok) document.getElementById(\'action\').value=\'remove\';submit();" value="remove"></input>';
  $out .= '<input type="button" class="i" name="action"'
       .  ' onclick="var ok=confirm(\''.$tabname.': table truncate?\');'
       .  ' if (ok) document.getElementById(\'action\').value=\'truncate\';submit();" value="truncate"></input>';
  $out .= '<input type="button" class="i" name="action"'
       .  ' onclick="document.getElementById(\'an\').style.display=\'inline\'"'
       .  ' value="rename"></input>'
       .  '<input type="text" id="an" name="new_name" style="display:none" onchange="submit()"></input>';
  $out .= '<input type="button" class="i" name="action" title="clone table definition [CREATE TABLE tab2 LIKE tab1]"'
       .  ' onclick="document.getElementById(\'ct\').style.display=\'inline\'"'
       .  ' value="clone"</input>'
       .  '<input type="text" id="ct" name="clone_tab" style="display:none" onchange="submit()"></input>';
  $out .= '<input type="button" class="i" name="action" title="copy table data on local host [INSERT INTO tab1 SELECT * FROM tab2]"'
       .  ' onclick="document.getElementById(\'cp\').style.display=\'inline\'"'
       .  ' value="copy data"></input>'
       .  '<input type="text" id="cp" name="copy" style="display:none" onchange="submit()"></input>';
  $out .= '<input type="button" class="j" name="action" title="clone remote table definition to local [CREATE TABLE l_tab LIKE r_tab]"'
       .  ' onclick="document.getElementById(\'crt\').style.display=\'inline\'"'
       .  ' value="clone remote table"></input>'
       .  '<input type="text" id="crt" name="clone_tab_remote" style="display:none" onchange="submit()"></input>';
  $out .= '<input type="button" class="j" name="action"'
       .  ' onclick="document.getElementById(\'action_sync\').value=\'sync\';submit();" value="sync remote table"></input>';
  $out .= '<input type="button" class="j" name="action" title="sync local table data: 1x click to get table selection, 2x click to start"'
       .  ' onclick="document.getElementById(\'sy\').style.display=\'inline\'"'
       .  ' ondblclick="document.getElementById(\'action_sync\').value=\'sync_local\';submit();"'
       .  ' value="sync local tables"></input>'
       .  '<select id="sy" name="sync_local" style="width:100px;display:none">';
  foreach ($tabliste as $i)
    $out .= ($i==$_REQUEST['sync_local']?'<option selected>':'<option>').$i.'</option>';
  $out .= '</select>';
  print $out . '</fieldset>';
  if ($_REQUEST['action_sync'] == 'sync')       print sync($dsn,$mdb2,$tab,$r_tabname);
  if ($_REQUEST['action_sync'] == 'sync_local') print synclocal($dsn,$tab);
  print '</form><br/><center><a href="'. $_SERVER['PHP_SELF'] .'?remote_url='.$remote_url.'">new action?</a></center></body></html>';
?>